#! /usr/bin/python2.7
# -*- coding: UTF-8 -*-

#############################################################################
#
# Copyright (C) Labomedia February 2012
#
#  This program is free software; you can redistribute it and/or
#  modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2
#  of the License, or (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software Foundation,
#  Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
#############################################################################

import time
import threading
import socket
import re
import sys
sys.path.append("./OSC")
import OSC
sys.path.append("./pyFluidSynth")

previous = {}
var_dict ={}
tempo = 0
stop_listen = False
stop_keyboard = False
config = {}
socketOSC = []
time0 = int(time.time())

# TODO : rewrite what_else

def main():
    # Enter ip and phone
    test = False
    if not test:
        ip = raw_input('What is your IP ? ')
        phone = int(raw_input('How many phones ? '))
    else:
        ip = '10.0.0.4'
        phone = 4

    # Add key in config dict with ip, port, buffer
    buff_size = 1024
    for i in range(phone):
        config[i] = (ip, 8000+i, buff_size)
    print 'Your IP is', ip
    print 'Range Port is 8000 to', 8000+i
    # Set and plug
    plug()
    set_audio()
    print 'Press q + Enter to quit\n'

    # Thread listen
    global thread1
    ##stop_listen = False
    thread1=threading.Thread(target=thread_listen)
    thread1.start()

    # Thread keyboard quit with q
    global thread2
    ##stop_keyboard = False
    thread2=threading.Thread(target=thread_keyboard)
    thread2.start()

def thread_listen():
    while not stop_listen:
        listen()
        if stop_keyboard:
            print 'Exit thread listen'
            exit(0)

def thread_keyboard():
    global stop_keyboard
    while not stop_keyboard:
        c = sys.stdin.read(1)
        if c == 'q':  # exit program
            print 'Exit thread keyboard'
            stop_listen = True
            stop_keyboard = True
            thread1.join()

def plug():
    for key in config.keys():
        ip = config[key][0]
        port = config[key][1]
        buffer_size = config[key][2]
        socketOSC.append(0)
        socketOSC[key] = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
        try:
            socketOSC[key].bind((ip, port))
            socketOSC[key].setblocking(0)
            socketOSC[key].settimeout(0.002)
            socketOSC[key].setsockopt(socket.SOL_SOCKET, socket.SO_RCVBUF, buffer_size)
            print('Plug : IP = {} Port = {} Buffer Size = {} '.format(ip, port, buffer_size))
        except:
            print('No connected to IP = {} Port = {}'.format(ip, port))
            pass

def listen():
    if not stop_keyboard:
        for key in config.keys():
            try:
                time.sleep(0.01)
                raw_data = socketOSC[key].recv(config[key][2])
                data = OSC.decodeOSC(raw_data)
                convert_data(data, key)
                musik()
            except socket.error:
                pass

def convert_data(data, n):
    '''Convert OSC message in variable'''
    # if list
    if isinstance(data, list):
        if len(data) > 1 :
            # if bundle cut bundle and time
            if data[0]=='#bundle':
                # Cut the two first item
                data = data[2:]
            test_if_list_of_list(data, n)
    else:
        pass

def test_if_list_of_list(data, n):
    '''test if first in list is a list'''
    if isinstance(data[0], list):
        for i in range(len(data)):
            list_to_var(data[i])
    else:
        list_to_var(data, n)

def list_to_var(data, n):
    '''Set value in variable'''
    # First item is the tag, otherwise message in not osc
    var_name = name(data[0], n)
    # if the second is type of all values, example 'iif
    if isinstance(data[1], str) or data[1][0] == ",":
        # cut the 2 first
        data = data[2:]
    # cut the first: msg don't respect OSC format
    else:
        data = data[1:]
    # data is always list, convert list to int or float or str if len=1
    if len(data)==1:
        data = data[0]
    var_dict[var_name] = data

def name(s, n):
    '''Convert s in variable name'''
    # Cut the first / if
    if s[0] == '/':
        s = s[1:]
    # add socket number in front to identify the socket and separate identical name
    # so the first item is never a number
    s = 'n' + str(n) + '_' + s
    # Replace / or - or , with _ (add str in list if necessary)
    for i in ['/', '-', ',']:
        s = s.replace(i, '_')
    return s

def musik():
    # go to what else if new value in var_dict
    for key, value in var_dict.items():
        if previous.has_key(key):
            if previous[key] != value:
                previous[key] = value
                what_else(key)
        else:
            previous[key] = value
            what_else(key)

def what_else(key):
    # klavier 1 to 12 with panel 1
    if key.find('1_push') != -1:
        if int(var_dict[key]) == 1:
            channel = 1
            volume = 100
            note = 47+int(key[9:])
            life = 1
            thread_note(note, life, channel, volume)

    # select channel, volume, note with fader3
    if key.find('2_push') != -1:
        if int(var_dict[key]) == 1:
            if var_dict.has_key(key.split("_")[0]+'_3_fader1'):
                channel = 1 + int(15*var_dict[key.split("_")[0]+'_3_fader1'])
            else:
                channel = 9
            if var_dict.has_key(key.split("_")[0]+'_3_fader2'):
                volume = 47 + int(80*var_dict[key.split("_")[0]+'_3_fader2'])
            else:
                volume = 100
            note = 47 + int(key[9:])
            life = 0.2
            thread_note(note, life, channel, volume)

    # play violin
    if key.find('3_fader3') != -1:
        if var_dict.has_key('n3_3_toggle1'):
            if int(var_dict['n3_3_toggle1']) == 1:
                if var_dict.has_key(key.split("_")[0]+'_3_fader1'):
                    channel = 1 + int(15*var_dict[key.split("_")[0]+'_3_fader1'])
                else:
                    channel = 9
                if var_dict.has_key(key.split("_")[0]+'_3_fader2'):
                    volume = 47 + int(80*var_dict[key.split("_")[0]+'_3_fader2'])
                else:
                    volume = 100
                note = int(127*var_dict['n3_3_fader3'])
                life = 0.2
                thread_note(note, life, channel, volume)

    # xylophone 1 to 96 with 2_multitoggle
    if key.find('2_multitoggle') != -1:
        if int(var_dict[key]) == 1:
            note = 21+int(key.split("_")[4])+((int(key.split("_")[3])-1)*16)
            volume = 100
            life = 0.2
            channel = 13
            thread_note(note, life, channel, volume)

def set_audio():
    try:
        import fluidsynth
        global fs
        fs = fluidsynth.Synth()
        fs.start(driver='alsa')
        # This path is a problem because it's absolute
        sfid = fs.sfload("/usr/share/sounds/sf2/FluidR3_GM.sf2")

        # .program_select(channel,    sfid,   bank,   bank number)
        fs.program_select(  1  ,      sfid,   0,      0  ) # yamaha grand piano
        fs.program_select(  2  ,      sfid,   0,      40 ) # violin
        fs.program_select(  3  ,      sfid,   0,      37 ) # pop bass
        fs.program_select(  4  ,      sfid,   0,      56 ) # trompet
        fs.program_select(  5  ,      sfid,   0,      66 ) # tenor sax
        fs.program_select(  6  ,      sfid,   0,      114) # steel drums
        fs.program_select(  7  ,      sfid,   0,      118) # synth drum
        fs.program_select(  8  ,      sfid,   0,      119) # reverse cymbal
        fs.program_select(  9  ,      sfid,   0,      116) # taiko drum
        fs.program_select(  10  ,     sfid,   0,      73 ) # flute
        fs.program_select(  11  ,     sfid,   0,      70 ) # basson
        fs.program_select(  12  ,     sfid,   0,      46 ) # harp
        fs.program_select(  13  ,     sfid,   0,      13 ) # xylophone
        fs.program_select(  14  ,     sfid,   0,      24 ) # nylon string guitar
        fs.program_select(  15  ,     sfid,   0,      25 ) # steel string guitar
        fs.program_select(  16  ,     sfid,   0,      29 ) # overdrive guitar

    except:
        print ("For sound synthetizer, you must install:")
        print ("sudo apt-get install fluidsynth fluid-soundfont-gm fluid-soundfont-gs")
        pass

def playNote(note, life, channel, volume):
    # note from 0 to 127 but all values are not possible in all bank
    # life 0 to ?
    # channel 1 to 16
    # volume 0 to 127
    fs.noteon(channel, note, volume)
    time.sleep(life)
    fs.noteoff(channel, note)

def thread_note(note, life, channel, volume):
    thread3 = threading.Thread(target=playNote, args=(note, life, channel, volume))
    thread3.start()
    print "Play note =", note, "Volume =", volume, "Channel =", channel, "Life =", life

main()
